]> git.proxmox.com Git - mirror_qemu.git/blame - scripts/archive-source.sh
i386: Remove unused host_cpudef variable
[mirror_qemu.git] / scripts / archive-source.sh
CommitLineData
6b560c76
FZ
1#!/bin/bash
2#
3# Author: Fam Zheng <famz@redhat.com>
4#
5# Archive source tree, including submodules. This is created for test code to
6# export the source files, in order to be built in a different environment,
7# such as in a docker instance or VM.
8#
9# This code is licensed under the GPL version 2 or later. See
10# the COPYING file in the top-level directory.
11
12error() {
13 printf %s\\n "$*" >&2
14 exit 1
15}
16
17if test $# -lt 1; then
18 error "Usage: $0 <output tarball>"
19fi
20
934821eb 21tar_file=$(realpath "$1")
8fc76176
GH
22sub_tdir=$(mktemp -d "${tar_file%.tar}.sub.XXXXXXXX")
23sub_file="${sub_tdir}/submodule.tar"
6b560c76 24
47bb908d
DB
25# We want a predictable list of submodules for builds, that is
26# independent of what the developer currently has initialized
27# in their checkout, because the build environment is completely
28# different to the host OS.
7c57bdd8 29submodules="dtc slirp ui/keycodemapdb tests/fp/berkeley-softfloat-3 tests/fp/berkeley-testfloat-3"
8fc76176 30sub_deinit=""
47bb908d 31
8fc76176
GH
32function cleanup() {
33 local status=$?
34 rm -rf "$sub_tdir"
35 if test "$sub_deinit" != ""; then
36 git submodule deinit $sub_deinit
37 fi
38 exit $status
39}
40trap "cleanup" 0 1 2 3 15
47bb908d
DB
41
42if git diff-index --quiet HEAD -- &>/dev/null
43then
44 HEAD=HEAD
45else
934821eb 46 HEAD=$(git stash create)
6b560c76
FZ
47fi
48
8fc76176
GH
49git archive --format tar $HEAD > "$tar_file"
50test $? -ne 0 && error "failed to archive qemu"
47bb908d 51for sm in $submodules; do
8fc76176
GH
52 status="$(git submodule status "$sm")"
53 smhash="${status#[ +-]}"
54 smhash="${smhash%% *}"
55 case "$status" in
56 -*)
57 sub_deinit="$sub_deinit $sm"
58 git submodule update --init "$sm"
59 test $? -ne 0 && error "failed to update submodule $sm"
60 ;;
61 +*)
62 echo "WARNING: submodule $sm is out of sync"
63 ;;
64 esac
65 (cd $sm; git archive --format tar --prefix "$sm/" $smhash) > "$sub_file"
66 test $? -ne 0 && error "failed to archive submodule $sm ($smhash)"
67 tar --concatenate --file "$tar_file" "$sub_file"
68 test $? -ne 0 && error "failed append submodule $sm to $tar_file"
47bb908d 69done
6b560c76 70exit 0